<template>
  <form @submit.prevent="form.post(`/issuance/staff/${user.id}`, { preserveScroll: true })">
    <div class="box p-3 md:p-6">
      <div class="text-base font-bold text-gray-700 mb-3">Issue fields</div>
      <div class="space-y-7">
        <div v-for="(filledRoleField, index) in frfs">
          <label class="block text-base font-medium text-gray-700"
            :class="{ 'opacity-30': filledRoleField.role_field.foreigner_field && form.nationality === 'Bhutanese' }">{{
              index + 1 }}.{{ filledRoleField.role_field.field.name }}
            <span v-if="filledRoleField.role_field.foreigner_field" class="text-orange-500">(Only for foreigners)</span>
            <span v-if="filledRoleField.role_field.field.required" class="text-lg text-orange-500">*</span>
          </label>
          <fieldset class="mb-1"
            :disabled="filledRoleField.role_field.foreigner_field && form.nationality === 'Bhutanese'">
            <input v-model="form.filled_role_fields[index].value" class="w-full input" type="text"
              v-if="filledRoleField.role_field.field.type === 'Text'" />
            <input v-model="form.filled_role_fields[index].value" class="w-full input" type="number"
              v-else-if="filledRoleField.role_field.field.type === 'Number'" />
            <input v-model="form.filled_role_fields[index].value" class="w-full input" type="date"
              v-else-if="filledRoleField.role_field.field.type === 'Date'" />
            <div v-else-if="filledRoleField.role_field.field.type === 'File'">
              <div v-if="form.filled_role_fields[index].file">
                <div class="flex items-center gap-3" :class="{ 'opacity-30': form.filled_role_fields[index].delete }">
                  <Icon icon="fa-solid fa-file" class="text-gray-600 text-4xl"></Icon>
                  <div>{{ filledRoleField.role_field.field.name }}.{{
                    form.filled_role_fields[index].file.filename.split('.').pop() }}</div>
                </div>
                <div>
                  <input type="checkbox" class="checkbox" v-model="form.filled_role_fields[index].delete" /><label
                    class="text-sm ms-2">Delete old file</label>
                </div>
                <div class="mt-4 text-sm" :class="{ 'opacity-30': !form.filled_role_fields[index].delete }">Pick another
                  file</div>
                <input :disabled="!form.filled_role_fields[index].delete"
                  @change="(event) => form.filled_role_fields[index].value = event.target.files[0]"
                  class="w-full input-file" type="file" />
              </div>
              <input v-else @change="(event) => form.filled_role_fields[index].value = event.target.files[0]"
                class="w-full input-file" type="file" />
            </div>
            <textarea v-model="form.filled_role_fields[index].value" class="w-full textarea"
              v-else-if="filledRoleField.role_field.field.type === 'Text Area'" />
            <div v-else-if="filledRoleField.role_field.field.type === 'Checkbox'">
              <fieldset v-for="option in filledRoleField.role_field.field.options">
                <input v-model="form.filled_role_fields[index].value" :value="option.id" type="checkbox"
                  class="checkbox">
                <label class="text-sm ms-2">{{ option.value }}</label>
              </fieldset>
            </div>
            <div v-else-if="filledRoleField.role_field.field.type === 'Radio Button'">
              <fieldset v-for="option in filledRoleField.role_field.field.options">
                <input v-model="form.filled_role_fields[index].value" :value="option.id" type="radio" class="radio">
                <label class="text-sm ms-2">{{ option.value }}</label>
              </fieldset>
            </div>
            <select v-model="form.filled_role_fields[index].value" class="w-full dropdown"
              v-else-if="filledRoleField.role_field.field.type === 'Dropdown'">
              <option v-for="option in filledRoleField.role_field.field.options">
                {{ option.value }}
              </option>
            </select>
            <!-- error -->
            <div v-if="form.errors[`${filledRoleField.role_field.id}id`]" class="text-error">
              {{ form.errors[`${filledRoleField.role_field.id}id`] }}
            </div>
          </fieldset>
          <div class="text-sm flex flex-col md:flex-row gap-x-5">
            <label v-if="filledRoleField.role_field.issuable" class="text-orange-500 font-semibold">
              <Icon icon="fa-solid fa-hand-holding-hand"></Icon> Issuable
            </label>
            <label v-if="filledRoleField.role_field.alertable" class="text-orange-500 font-semibold">
              <Icon icon="fa-solid fa-circle-exclamation"></Icon> Alert ({{ filledRoleField.role_field.alert_period }})
            </label>
          </div>
        </div>
      </div>

      <div class="flex gap-x-3 mt-3 flex-row-reverse">
        <button class="btn green"> Save</button>
        <button type="button" class="btn orange">
          Cancel
        </button>
      </div>
    </div>
  </form>
</template>

<script setup>
import { useForm } from '@inertiajs/vue3';
import { ref } from 'vue';

const props = defineProps({
  filledRoleFields: Array,
  user: Object
})

const frfs = ref(props.filledRoleFields.sort((filledRoleFieldA, filledRoleFieldB) => filledRoleFieldA.role_field.field.index - filledRoleFieldB.role_field.field.index));

const form = useForm({
  _method: 'put',
  filled_role_fields: props.filledRoleFields.sort((filledRoleFieldA, filledRoleFieldB) => filledRoleFieldA.role_field.field.index - filledRoleFieldB.role_field.field.index).map(
    (filledRoleField) => filledRoleField.role_field.field.type === 'Checkbox' ? { roleField: filledRoleField.role_field, id: filledRoleField.id, value: filledRoleField.selected_options.map((selected_option) => selected_option.id) } :
      filledRoleField.role_field.field.type === 'File' ? { roleField: filledRoleField.role_field, id: filledRoleField.id, value: "", file: filledRoleField.file, delete: false } :
        { roleField: filledRoleField.role_field, id: filledRoleField.id, value: filledRoleField.value })
});
</script>